program bircserv;

{$include bircserv.inc}

uses
  {$ifdef win32}
  wsocket,
  wcore,
  {$else}
  lcore,
  lsocket,
  bunixsignals,
  unitfork,
  {$endif}
  {$ifndef nowinnt}
  bwinnt,
  {$endif}

  sysutils,rndpass,bircservunit;

{
* ignore nickchange only case
* it expired nicks w/o decreasing the counter in the motd
* register now requires "pass email"

* dont start if there is a pid file

* add code to coexist with another channel service in the same channel:
  dont deop it, dont bounce it's modes etc.
  also dont allow register a channel which has a +k in it unless done by oper
  (document this assumes chanserv sitting in channel)

* autosave every 180 secs

* newest version of linux/unix units. can compile on fpc 1.9 now.
* fork/pidfile handling: dont start if the pid file is present.

* option to store passwords plaintext, for conversion (xirc)

* send AA] for maxclients, allowing the numerics to fit in short numerics range

* add "numeric" to operserv whois command

* removed floating point problem code from rndpass

- simple sanity check for email in register

- STRICTOP bug: no access to AOP if on VOP list (cant reproduce) - P^S: TM knows.

- <Ping^Spike> recent bug is being able to register a nickname without a password :) - TM knows?

}

procedure getpath;
var
  s:string;
  a,b:integer;
begin
  s := paramstr(0);
  b := 0;
  for a := length(s) downto 1 do begin
    if (s[a] = '\') or (s[a] = '/') then begin
      b := a;
      break;
    end;
  end;
  if b = 0 then exit;
  s := copy(s,1,b-1);
  chdir(s);
end;

begin
  getpath;

  {$ifndef nowinnt}
    if paramstr(1) = 'install' then begin
      installservice(paramstr(2) = 'auto');
      halt;
    end;

    if paramstr(1) = 'uninstall' then begin
      uninstallservice;
      halt;
  end;

    if ntservicemarked then begin
      if runservice then halt;
    end;
  {$endif}

  {$ifdef unix}
    if not checkpid(pidfile) then begin
      exit;
    end;
  {$endif}

  runapplication;
end.
